grub_script_expansion.in 1.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445
  1. #! @BUILD_SHEBANG@
  2. set -e
  3. # Run GRUB script in a Qemu instance
  4. # Copyright (C) 2010 Free Software Foundation, Inc.
  5. #
  6. # GRUB is free software: you can redistribute it and/or modify
  7. # it under the terms of the GNU General Public License as published by
  8. # the Free Software Foundation, either version 3 of the License, or
  9. # (at your option) any later version.
  10. #
  11. # GRUB is distributed in the hope that it will be useful,
  12. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  13. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  14. # GNU General Public License for more details.
  15. #
  16. # You should have received a copy of the GNU General Public License
  17. # along with GRUB. If not, see <http://www.gnu.org/licenses/>.
  18. disks=`echo ls | @builddir@/grub-shell`
  19. disks=`echo "$disks"| grep -av '^Network protocols:$'| grep -av '^tftp http $'`
  20. other=`echo insmod regexp\; echo \* | @builddir@/grub-shell`
  21. for d in $disks; do
  22. if echo "$d" |grep ',' >/dev/null; then
  23. if echo "$other" | grep -F -- "$d" >/dev/null; then
  24. echo "$d should not occur in * expansion" >&2
  25. exit 1
  26. fi
  27. else
  28. if ! echo "$other" | grep -F -- "$d" >/dev/null; then
  29. echo "$d missing from * expansion" >&2
  30. exit 1
  31. fi
  32. fi
  33. done
  34. other=`echo insmod regexp\; echo '(*)' | @builddir@/grub-shell`
  35. for d in $disks; do
  36. if ! echo "$other" | grep -F -- "$d" >/dev/null; then
  37. echo "$d missing from (*) expansion" >&2
  38. exit 1
  39. fi
  40. done